/* This file is part of Threadloger.
 *
 * Threadloger is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Threadloger is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Threadloger; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
#ifndef DELOG_H_060905
#define DELOG_H_060905

#include <stdbool.h>
#include "threadlog/log.h"

/*
 * Delog Datas & services
 */

extern char const *log_dir;
extern unsigned max_depth;
extern enum log_level min_level;

enum display_mode { REFERERS, REFERED, CHRONO, NB_DISP_MODES };

int foreach_msg(logid_t root, enum display_mode dmode, unsigned max_depth, int (*cb)(logid_t id, unsigned depth, void *), void *data);

/*
 * Nc interface
 */

int nc_begin(char const *lib);
void nc_end(void);

enum browse_action {
	ERROR,
	NOP,
	QUIT,
	SELECT,
	CHG_DISPMODE,
	CHG_FOLD,
	BACK,
	LEVEL_UP,
	LEVEL_DOWN
};
void nc_display_status_line(enum display_mode dmode, bool unfold_all);
void nc_display_history(logid_t *history);
enum browse_action nc_browse_msg(logid_t root, logid_t cursor_pref, enum display_mode dmode, bool unfold_all, logid_t *selected);

#endif
