/* This file is part of Threadloger.
 *
 * Threadloger is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * Threadloger is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with Threadloger; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */
#ifndef THREADLOGD_H_060829
#define THREADLOGD_H_060829

#include <signal.h>
#include <time.h>
#include "threadlog/logd.h"
#include "threadlog/pool.h"
#include "client.h"

#define DEFAULT_LOG_DIR "/var/loger"
#define DEFAULT_LOG_PERIOD 86400	// 1 day
#define DEFAULT_POOL_FILE "/tmp/loger.pool"
#define DEFAULT_PORT 62000
#define DEFAULT_LOG_SIZE 10

#define MY_LOG(level, ...) logd.log.ops->print(&logd.log, level, time(NULL), NULL, __VA_ARGS__)
#define MY_ERROR(...) MY_LOG(log_ERROR, __VA_ARGS__)
#define MY_WARNING(...) MY_LOG(log_WARNING, __VA_ARGS__)

extern volatile sig_atomic_t terminate;
extern struct logd logd;
extern struct pool pool;

int service(unsigned short port);

#endif
